#ifndef __compiler_h_
#define __compiler_h_ 1


#if !defined(BV)
#  define BV(A) (1<<A)
#endif
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


#define FLASH  __attribute__ ((progmem))
#define EEPROM __attribute__ ((section(".eeprom")))
#define NAKED  __attribute__ ((naked))
#define CTASK  __attribute__ ((noreturn))
#define NAKEDFUNC(A) void A(void) NAKED; void A(void)
#define CTASKFUNC(A) void A(void) CTASK; void A(void)
#define INTERFACE

#ifndef cli
#define cli() asm volatile ("cli\n")
#define sei() asm volatile ("sei\n")
#endif
#define outp(A,B) B = (A)
#define inp(A) A
#define cbi(P, B) P &= ~BV(B)
#define sbi(P, B) P |= BV(B)

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -



typedef unsigned char    byte;
typedef   signed char    int8;
typedef unsigned char   uint8;

 #if __INT_MAX__ == 127 //-mint8
  typedef unsigned long    word;
  typedef long            int16;
  typedef unsigned long  uint16;

  typedef unsigned long long  dword;
  typedef long long           int32;
  typedef unsigned long long uint32;

 #else
  typedef unsigned int     word;
  typedef   signed int    int16;
  typedef unsigned int   uint16;

  typedef unsigned long      dword;
  typedef long               int32;
  typedef unsigned long     uint32;

  typedef long long           int64;
  typedef unsigned long long uint64;
 #endif

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


union b_word {
   word  w;
   byte  b[2];
   };
#define low( A)  ((union b_word)A).b[0]
#define high(A)  ((union b_word)A).b[1]




//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#endif
