#include "avr/io.h"
#include "avr/pgmspace.h"
#include "stdint.h"
#include "stdio.h"
#include "speaker.h"

#define pd_AUDIO  DDRD
#define po_AUDIO  PORTD
#define  b_AUDIO      7


#ifndef strchr_P
char *strchr_P(const void* aStr, char Chr)
{
char* Str=(char*)aStr;
   for(;;){
     char a=pgm_read_byte(Str++);
     if(a==Chr) return --Str;
     if(!a)break;
   }
  return NULL;
}
#endif

//-----------------------------------------------------------------

//#define FonTime 0x1200 //  // 1000h  //800h   //400h    //char delay time
//#define BitTime  11    //12 ; //    17  //  16    // 20      //bit delay  time

//#define _FonTime 3400
//#define _BitTime 11

//#define _FonTime 2600
//#define _BitTime 13


#define _FonTime 2300//2300
#define _BitTime 16 //16   //Optimal :(

//#define _FonTime 1800  //2400 //3000 //# 0x1100 //0x1200
//#define _BitTime 7    //17   //10   //# 16      // 11


uint16_t FonTime = _FonTime;
uint8_t  BitTime = _BitTime;

//-----------------------------------------------------------------

static void tembr_btn(void)
{
static uint8_t k;
static uint8_t i=0;
   DDRC&= ~(1<<0); PORTC|=(1<<0); //Set As input
   k<<=1; k+= !!(PINC&(1<<0));
   if((k&0x03)==0x02){//falling edge detect
	 switch(++i){
           case  1: set_speech(28,1400) ;break;
           case  2: set_speech(22,1600) ;break;
           case  3: set_speech(17,2300) ;break;
           case  4: set_speech(13,2600) ;break;
           case  5: set_speech(11,3400) ;break;
           case  6: set_speech( 8,3800) ;break;
           case  7: set_speech( 7,1800) ;break;
           case  8: set_speech(41,1550) ;break;
           case  9: set_speech(35,1500) ;break;
           case 10: set_speech( 8,2000) ;break;
           case 11: set_speech(10,2500) ;break;
           default: i=0;
     }
         printf_P(PSTR(" { Ft=%u, Bt=%u } "),FonTime,BitTime);
   }
}

static void print_chk(uint8_t a)
{
static char xx=0;
     if((xx++)>50){putchar('\n'); xx=0; }
     if(a=='\n') xx=0;
     ;
     tembr_btn();//###

}


//-----------------------------------------------------------------
#ifndef F_CPU
#define F_CPU 11059200UL
#warning "Not defined F_CPU in makefile"
#endif
#define F_CLK ((F_CPU/100000)/3)    // 11059200/100000/3 = 0x24

static __inline__ void  _delay_clk_x3(uint8_t __count)
{
   __asm__ volatile (
      "1: dec %0" "\n\t"
      "brne 1b"
      : "=r" (__count)
      : "0" (__count)
   );
}
#define delay_us(Time_uS) _delay_clk_x3(  (F_CLK* (Time_uS) +3 )/10   )
//- - - - - - - - - -
static void pause_sample(void)
{//Delay ~2.3mS at FonTime=400h
  for(uint16_t t=FonTime;t;t--) delay_us(2);
}
static void delay_bit_out(void)
{
  for(uint8_t t=BitTime;t;t--) delay_us(5);
}

//-----------------------------------------------------------------

static uint8_t PlayLetterRus(uint8_t First,uint8_t Secnd);
static uint8_t PlayLetterENG(uint8_t First,uint8_t Secnd);





//==================================================================

uint8_t ToUpper(uint8_t A)
{
  if( (A>='a')&&(A<='z') ) A&=0x5F;
  else
  {//conversion CP866
//0x80: - //0x90: -  //0xA0: - //0xE0: -  F0= F1=
        if( (A>=0xA0)&&(A<=0xAF) ) A-=0x20; // .. -> -
   else if( (A>=0xE0)&&(A<=0xEF) ) A-=0x50; // .. -> -
   else if(  A==0xF1) A=0xF0;               //     -> 
  }
  return A;
}


static inline void pause_Punctuation(uint8_t aChar)
{
uint8_t t;
       t=0x48; if(aChar=='.')goto _pause;
       t=0x48; if(aChar=='!')goto _pause;
       t=0x48; if(aChar=='?')goto _pause;
       t=0x24; if(aChar==',')goto _pause;
       t=0x12; if(aChar==' ')goto _pause;
       t=0x5;  if(aChar=='~')goto _pause; // ⢥म 
	   return;
_pause:
	  for(;t;t--)pause_sample();
}

//----------------------------------------------------------------------




void _PlayStr(const char inPGM,char* Pstr)
{
uint8_t First,Secnd,Len;
  for(;;Pstr++)
  {
    if(inPGM){ First=pgm_read_byte(Pstr+0); Secnd=pgm_read_byte(Pstr+1); }
    else     { First= *(Pstr+0);            Secnd= *(Pstr+1);            }
    if(!First)return; //end of text;
    putchar(First);print_chk(First);
    Len=PlayLetterRus(First,Secnd);
    if(Len)putchar(Secnd);
    Pstr+=Len;
  }
}


//----------------------------------------------------------------------

static void Out_SoudSample(uint16_t SndAddr,uint8_t Len)
{//ந ᥬ ⭮. (⨬쭠  ~9.6kHz)
uint8_t Msk=0x80;
  if(Len)// 㫥  ⮫쪮 ࠡ⪠ ᥬ 
  {
    for(;Len;Len--)
    {
      if( pgm_read_byte(SndAddr)&Msk ) po_AUDIO|=  (1<<b_AUDIO);
      else                             po_AUDIO&= ~(1<<b_AUDIO);
      delay_bit_out();
   	  if((Msk>>=1)==0){Msk=0x80; SndAddr++; } //室  ᫥騩 ?
    }
  }
//  po_AUDIO&= ~(1<<b_AUDIO);
  pause_sample(); //㧠  ᥬ
}

//=======================================================================


uint8_t PROGMEM sound_A        []={(  46), 0xE1,0xC3,0xE1,0xC7,0x8F,0x0F };
uint8_t PROGMEM sound_E        []={(  46), 0xF8,0x03,0x0F,0x07,0xC1,0xE3 };
uint8_t PROGMEM sound_I        []={(  46), 0xFF,0x40,0x17,0xFF,0x00,0x03 };
uint8_t PROGMEM sound_O        []={(  46), 0xF8,0x7C,0xC1,0xF1,0xF8,0x03 };
uint8_t PROGMEM sound_U        []={(  46), 0xFE,0x00,0x7F,0xFC,0x00,0x03 };

uint8_t PROGMEM sound_closed0  []={(   0)                                };
uint8_t PROGMEM sound_closed   []={(  46), 0x00,0x00,0x00,0x00,0x00,0x00 };

uint8_t PROGMEM sound_L        []={(  46), 0xFE,0x03,0xC0,0xFF,0x00,0x00 };
uint8_t PROGMEM sound_M        []={(  46), 0xFF,0xF8,0x00,0x7F,0xF8,0x03 };
uint8_t PROGMEM sound_N        []={(  46), 0xFF,0xF0,0x01,0xFF,0xE0,0x03 };
uint8_t PROGMEM sound_B        []={(  46), 0xAA,0xCA,0x5A,0xD5,0x21,0x3D };

uint8_t PROGMEM sound_H        []={(  46), 0xE1,0x5C,0x35,0xC5,0xAA,0x35 };

uint8_t PROGMEM sound_2DNT2    []={(  46), 0xEF,0x40,0x17,0xFF,0x00,0x03 };


uint8_t PROGMEM sound_G_K2     []={(  94), 0x3E,0x8E,0x38,0x73,0xCF,0xF8,0x78,0xC3,0xDF,0x1C,0xF1,0xC7 };
uint8_t PROGMEM sound_G_K      []={(  90), 0x3E,0x8E,0x38,0x73,0xCF,0xF8,0x78,0xC3,0xDF,0x1C,0xF1,0xC7 };

uint8_t PROGMEM sound_opn_HMNV []={(  46), 0xFF,0xFC,0x20,0x00,0x00,0x03 };

uint8_t PROGMEM sound_2V2      []={(  46), 0xFF,0xFF,0x08,0x79,0x00,0x02 };
uint8_t PROGMEM sound_3V2      []={(  46), 0xFF,0xE1,0xC7,0x1F,0xE0,0x03 };


uint8_t PROGMEM sound_soft1    []={(  46), 0xFF,0xD0,0x01,0xFF,0xF0,0x03 };
uint8_t PROGMEM sound_soft2    []={(  46), 0x7F,0x01,0xFA,0x5F,0xC0,0x07 };
uint8_t PROGMEM sound_soft3    []={(  46), 0xF8,0x0F,0xC0,0xFF,0x00,0x42 };


uint8_t PROGMEM sound_S        []={( 254), 0xAA,0xA5,0x55,0x5A, 0xAA,0xAA,0x5A,0xA5, 0x5A,0xAA,0x55,0x55, 0xAA,0xAA,0xA5,0x55 };
uint8_t PROGMEM sound_S1       []={(  46), 0xAA,0xA5,0x55,0x5A, 0xAA,0xAA                      };
uint8_t PROGMEM sound_S_z      []={(  46),           0x55,0x5A, 0xAA,0xAA,0x5A,0xA5            };
uint8_t PROGMEM sound_S_z2     []={(  46),                      0xAA,0xAA,0x5A,0xA5, 0x5A,0xAA };


uint8_t PROGMEM sound_CH       []={( 254), 0xB7,0x66,0x6C,0xD8, 0xF9,0xB3,0x6C,0xAD, 0x37,0x37,0x66,0xFC, 0x9B,0x87,0xF6,0xC0 };
uint8_t PROGMEM sound_ZH0      []={(  46), 0xB7,0x66,0x6C,0xD8, 0xF9,0xB3  };
uint8_t PROGMEM sound_ZH1      []={(  46),           0x6C,0xD8, 0xF9,0xB3,0x6C,0xAD };
uint8_t PROGMEM sound_ZH2      []={(  46),                      0xF9,0xB3,0x6C,0xAD, 0x37,0x37 };

uint8_t PROGMEM sound_4R2      []={(  94), 0xF7,0x3E,0x4D,0xFB, 0xFE,0x5D,0xB7,0xDE, 0x46,0xF6,0x96,0xB4 };
uint8_t PROGMEM sound_1R       []={(  46), 0xF8,0x0F,0x09,0xF1,0xFE,0x03 };
uint8_t PROGMEM sound_3R       []={(  46), 0xFE,0x1F,0xF8,0x00,0x00,0x1F };

uint8_t PROGMEM sound_D_T      []={(  46), 0xB7,0xDE,0x46,0xF6, 0x96,0xB4 };

uint8_t PROGMEM sound_F        []={( 254), 0x4F,0xAA,0xA9,0x55, 0xAA,0xAA,0xA5,0x69, 0x59,0x9A,0x6A,0x95,0x55,0x95, 0x55,0x6A,0xA5,0x55, 0xA9,0x4D,0x66,0x6A };

uint8_t PROGMEM sound_TH       []={(  94), 0x66,0x6A,0x92,0xEC,0xA5,0x55,0xD2,0x96,0x55,0xA2,0xBA,0xCD };

uint8_t PROGMEM sound_SH       []={( 254), 0x00,0x66,0x99,0xCC,0x67,0x31,0x8E,0x66,
                                           0x39,0xA6,0x6B,0x19,0x66,0x59,0xC6,0x71,
                                           0x09,0x67,0x19,0xCB,0x01,0x71,0xCC,0x73,
                                           0x19,0x99,0xCC,0xC6,0x67,0x19,0x9A,0xC6 };

//=======================================================================

typedef enum             {  snd_A,  snd_E,  snd_I,  snd_O,  snd_U,  snd_closed0,  snd_closed,  snd_L,  snd_M,  snd_N,  snd_B,  snd_H,  snd_2DNT2,  snd_G_K2,  snd_G_K,  snd_opn_HMNV,  snd_2V2,  snd_3V2,  snd_soft1,  snd_soft2,  snd_soft3,  snd_S,  snd_S1,  snd_S_z,  snd_S_z2,  snd_CH,  snd_ZH0,  snd_ZH1,  snd_ZH2,  snd_4R2,  snd_1R,  snd_3R,  snd_D_T,  snd_F,  snd_TH,  snd_SH}TSounds;
void* PROGMEM snd_list[]={sound_A,sound_E,sound_I,sound_O,sound_U,sound_closed0,sound_closed,sound_L,sound_M,sound_N,sound_B,sound_H,sound_2DNT2,sound_G_K2,sound_G_K,sound_opn_HMNV,sound_2V2,sound_3V2,sound_soft1,sound_soft2,sound_soft3,sound_S,sound_S1,sound_S_z,sound_S_z2,sound_CH,sound_ZH0,sound_ZH1,sound_ZH2,sound_4R2,sound_1R,sound_3R,sound_D_T,sound_F,sound_TH,sound_SH};

typedef struct {
     uint16_t  Addr;
     uint8_t   Len;
      }TSndBlock;

static TSndBlock get_soung_data(uint8_t SndCode)
{
 TSndBlock Result;
   Result.Addr=pgm_read_word( &snd_list[SndCode] );
   Result.Len =pgm_read_byte(Result.Addr++);
   return Result;
}

//=======================================================================

#define Stop  0x40
#define fonem(Sample,Repeats)   ((Sample<<8)|(Repeats&0x1F))

uint16_t PROGMEM f_JA []={ fonem(snd_soft1,4),  fonem(snd_soft2,2), fonem(snd_soft3,2) ,fonem(snd_A,8)+Stop  };
uint16_t PROGMEM f_JO []={ fonem(snd_soft1,4),  fonem(snd_soft2,2), fonem(snd_soft3,2) ,fonem(snd_O,8)+Stop  };
uint16_t PROGMEM f_JU []={ fonem(snd_soft1,4),  fonem(snd_soft2,2), fonem(snd_soft3,2) ,fonem(snd_U,8)+Stop  };

uint16_t PROGMEM f_A  []={ fonem(snd_A, 6)+Stop  };
uint16_t PROGMEM f_A2 []={ fonem(snd_A,15)+Stop  };
uint16_t PROGMEM f_E  []={ fonem(snd_E, 6)+Stop  };
uint16_t PROGMEM f_E2 []={ fonem(snd_E,14)+Stop  };
uint16_t PROGMEM f_I  []={ fonem(snd_I, 6)+Stop  };
uint16_t PROGMEM f_I2 []={ fonem(snd_I,14)+Stop  };
uint16_t PROGMEM f_O  []={ fonem(snd_O, 6)+Stop  };
uint16_t PROGMEM f_O2 []={ fonem(snd_O,14)+Stop  };
uint16_t PROGMEM f_U  []={ fonem(snd_U, 6)+Stop  };
uint16_t PROGMEM f_U2 []={ fonem(snd_U,14)+Stop  };
//- - - - - - - - - - - - - - -
uint16_t PROGMEM f_S  []={ fonem(snd_S  ,2)+Stop };
uint16_t PROGMEM f_SH []={ fonem(snd_SH ,2)+Stop };
uint16_t PROGMEM f_SCH[]={ fonem(snd_CH ,2)+Stop };
//- - - - - - - - - - - - - - -

#define _letter_V       fonem(snd_opn_HMNV,4),fonem(snd_2V2,2),fonem(snd_3V2,2)
#define _letter_F       fonem(snd_F     ,2)
#define _letter_B       fonem(snd_closed,4),   fonem(snd_B,1)
#define _letter_G       fonem(snd_closed,5),   fonem(snd_G_K,1)
#define _letter_P       fonem(snd_closed0, 8), fonem(snd_B,1)
#define _letter_K       fonem(snd_closed0, 8), fonem(snd_G_K,1)
#define _letter_K_hard  fonem(snd_closed0, 8), fonem(snd_G_K2,1)


uint16_t PROGMEM f_D []={ fonem(snd_closed, 4),  fonem(snd_D_T,1)+Stop };
uint16_t PROGMEM f_T []={ fonem(snd_closed0,8),  fonem(snd_D_T,1)+Stop };

uint16_t PROGMEM f_C []={ fonem(snd_closed0,8),  fonem(snd_S ,1)+Stop };

uint16_t PROGMEM f_G []={ _letter_G +Stop };
uint16_t PROGMEM f_K []={ _letter_K +Stop };


//- - - - - - - - - - - - - - -
uint16_t PROGMEM f_Q []={ _letter_K,_letter_V +Stop };
uint16_t PROGMEM f_X []={ _letter_K_hard, fonem(snd_S,2)+Stop };//KS
//- - - - - - - - - - - - - - -


//
uint16_t PROGMEM f_H  []={ fonem(snd_opn_HMNV,1),  fonem(snd_H, 4)+Stop };
uint16_t PROGMEM f_N  []={ fonem(snd_opn_HMNV,1),  fonem(snd_N, 6)+Stop };
uint16_t PROGMEM f_M  []={ fonem(snd_opn_HMNV,1),  fonem(snd_M, 6)+Stop };
uint16_t PROGMEM f_Mb []={ fonem(snd_opn_HMNV,1),  fonem(snd_M, 6), fonem(snd_opn_HMNV,1),  fonem(snd_M, 5), fonem(snd_2DNT2,2)+Stop };
uint16_t PROGMEM f_Nb []={ fonem(snd_opn_HMNV,1),  fonem(snd_M, 5), fonem(snd_2DNT2,2)+Stop };

uint16_t PROGMEM f_D2 []={ fonem(snd_closed ,3),  fonem(snd_TH,1), fonem(snd_2DNT2,2)+Stop };
uint16_t PROGMEM f_TH []={ fonem(snd_closed0,8),  fonem(snd_TH,1), fonem(snd_2DNT2,2)+Stop };


uint16_t PROGMEM f_Z  []={ fonem(snd_opn_HMNV,2),  fonem(snd_S1,2),
                          fonem(snd_S_z,2),  fonem(snd_S_z2,2)+Stop };

uint16_t PROGMEM f_L  []={ fonem(snd_L, 3),   fonem(snd_opn_HMNV,1)+Stop };
uint16_t PROGMEM f_R  []={ fonem(snd_1R,2),   fonem(snd_closed0,3), fonem(snd_3R,1)+Stop };



//- - - - - - - - - - - - - - -

uint16_t PROGMEM f_CH []={ fonem(snd_closed0,8),  fonem(snd_CH,1)+Stop };
uint16_t PROGMEM f_ZH []={ fonem(snd_ZH0,2),      fonem(snd_ZH1,2), fonem(snd_ZH2,2)+Stop };

//- - - - - - - - - - - - - - -


uint16_t PROGMEM f_B  []={ _letter_B +Stop };
uint16_t PROGMEM f_P  []={ _letter_P +Stop };
uint16_t PROGMEM f_F  []={ _letter_F +Stop };
uint16_t PROGMEM f_V  []={ _letter_V +Stop };
uint16_t PROGMEM f_Bb []={ _letter_B, fonem(snd_soft1,3),  fonem(snd_soft2,2), fonem(snd_soft3,2)+Stop };
uint16_t PROGMEM f_Pb []={ _letter_P, fonem(snd_soft1,3),  fonem(snd_soft2,2), fonem(snd_soft3,2)+Stop };
uint16_t PROGMEM f_Fb []={ _letter_F, fonem(snd_soft1,3),  fonem(snd_soft2,2), fonem(snd_soft3,2)+Stop };
uint16_t PROGMEM f_Vb []={ _letter_V, fonem(snd_soft1,3),  fonem(snd_soft2,2), fonem(snd_soft3,2)+Stop };
uint16_t PROGMEM f_J  []={            fonem(snd_soft1,3),  fonem(snd_soft2,2), fonem(snd_soft3,2)+Stop };

//- - - - - - - - - - - - - - -

uint16_t PROGMEM f_Rb []={ fonem(snd_closed0, 3),  fonem(snd_D_T,2),
                          fonem(snd_closed0, 3),  fonem(snd_4R2,1)+Stop };


//G2 J2 K2 L2 Q2 W2 X2
uint16_t PROGMEM f_NZ []={ fonem(snd_closed0,10)+Stop };

//============================================================================


typedef enum            {  _A, _B, _C, _D, _E, _F, _G, _H, _I, _J, _K, _L, _M, _N, _O, _P, _Q, _R, _S, _T, _U, _V, _X, _Z, _A2, _Bb, _CH, _D2, _E2, _Fb, _NZ, _SH, _I2, _Mb, _Nb, _O2, _Pb, _Rb, _SCH, _TH, _U2, _Vb, _ZH, _JA, _JO, _JU }Tfonem;
void* PROGMEM pFonems[]={ f_A,f_B,f_C,f_D,f_E,f_F,f_G,f_H,f_I,f_J,f_K,f_L,f_M,f_N,f_O,f_P,f_Q,f_R,f_S,f_T,f_U,f_V,f_X,f_Z,f_A2,f_Bb,f_CH,f_D2,f_E2,f_Fb,f_NZ,f_SH,f_I2,f_Mb,f_Nb,f_O2,f_Pb,f_Rb,f_SCH,f_TH,f_U2,f_Vb,f_ZH,f_JA,f_JO,f_JU };


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -



static void play_fonem(const Tfonem aFonem)
{
uint8_t* pFonem=(uint8_t*)pgm_read_word(&pFonems[aFonem]); //砥  ᯨ᪠ ⮢ 䮭
   pd_AUDIO|=(1<<b_AUDIO); po_AUDIO&= ~(1<<b_AUDIO);

   for(;;pFonem+=2)
   { //ந   ᪮쪨 䮭 㪢 (FonemPtr=addr)
     uint16_t FW=pgm_read_word(pFonem);
     TSndBlock snd=get_soung_data(FW>>8);
     for(uint8_t Rep=FW&0x1F;Rep;Rep--) Out_SoudSample(snd.Addr,snd.Len);
     if(FW&0x40)break;
   }
   po_AUDIO&= ~(1<<b_AUDIO);

}


//============================================================================


static uint8_t PlayLetterRus(uint8_t First,uint8_t Secnd)
{
static char    PROGMEM R1     []={'','','','','','','','','','','','','','','','','','','','','','','','','' ,'' ,''  ,'', '','','', '', '' };
static uint8_t PROGMEM R2     []={_A, _B, _V ,_G ,_D ,_E ,_JO,_ZH, _Z ,_I, _J, _K ,_L ,_M ,_N ,_O ,_P ,_R ,_S ,_T ,_U, _F ,_H ,_C ,_CH ,_SH, _SCH,_NZ, _I2,_NZ,_E ,_JU ,_JA };
static uint8_t PROGMEM R2_soft[]={_A, _Bb,_Vb,_G ,_D2,_E ,_JO,_ZH, _Z ,_I, _J, _K ,_L ,_Mb,_Nb,_O ,_Pb,_Rb,_S ,_T ,_U, _Fb,_H ,_C ,_CH ,_SH, _SCH,_NZ, _I2,_NZ,_E ,_JU ,_JA };
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

uint8_t Len=0;
   First=ToUpper(First); Secnd=ToUpper(Secnd);


   if(First<=0x7E){ // 7F    proteus. and R,R  ⠢ 䫠   ࠢ  0x80  ࠡ⠥.
     return PlayLetterENG(First,Secnd); // ਭ樯   ᪮ ࠡ뢠 ࠭᫨,   祣  .
  // pause_Punctuation(First);return Len; //㦥 ࠡ뢠  PlayLetterENG
   }

char* n;
   if( (n=(void*)strchr_P(R1,First)) !=NULL){ //᪠ 㪢
     uint8_t i=(n - R1);
     if(Secnd!='') First=pgm_read_byte(&R2[i]);
     else           First=pgm_read_byte(&R2_soft[i]);
     play_fonem(First);
     return Len;
   }


   return Len;
}



static uint8_t PlayLetterENG(uint8_t First,uint8_t Secnd)
{
                                // A   B   C   D   E   F   G   H   I   J   K   L   M   N   O   P   Q   R   S    T   U   V   W   X   Y   Z
                                //                     /    /                                              
static uint8_t PROGMEM Latin1[]={ _A ,_B ,_C ,_D ,_E ,_F, _G ,_H, _I, _J, _K ,_L ,_M ,_N ,_O ,_P ,_Q ,_R, _S  ,_T ,_U ,_V ,_V ,_X ,_I ,_Z  };
static uint8_t PROGMEM Latin2[]={ _A2,_Bb,_CH,_D2,_E2,_Fb,_NZ,_SH,_I2,_NZ,_NZ,_NZ,_Mb,_Nb,_O2,_Pb,_NZ,_Rb,_SCH,_TH,_U2,_Vb,_NZ,_NZ,_I2,_ZH };
                                // A:  B'  Ch  Dh? E:  F'  -   SH  I:  -   -   -   M'  N'  O:  P'  -   R'  Sch  Th  U:  V'  -   -   Y:  Zh
                                // :      ?, :    -      :  -   -   -       :    -         ?   :    -   -   :  

uint8_t Len=0;
   if( (Secnd=='\'')||(Secnd=='*') ) goto Alt_sym; // '  * 䨪  Latin2
   if( (Secnd=='~' )               ) goto play1;   // ~       䨪  Latin1
   //- - - - - - - -

   // ⠥    ᠭ,   ,   . :)
static uint8_t AAA_Cnt;
static uint8_t last;

   if( strchr_P(PSTR("AEIJOU"),First) ) AAA_Cnt++;  //᭠
   if( First<'A')                       AAA_Cnt=0; //ࠧ⥫ ᫮
   //
   if( (First=='C')&&(last<'A') ){ play_fonem(_K); return Len; } //' c' -> k
   last=First;
   //- - - - -

   if( (First=='E')&&(Secnd<='A')&&(last>='A')&& (AAA_Cnt>1) ){ play_fonem(_J); return Len; } //ਬ 'e'  , ᫨   ⢥ ᭠

   if  (First=='I'){ play_fonem(_A); play_fonem(_J); return ++Len; } //I  -> AJ
   if( (First=='C')&&(Secnd=='K') ){ play_fonem(_K); return ++Len; } //ck -> k

   if( (First<'A')|| (First>'Z') ) {pause_Punctuation(First);return Len;}
   //- - - - -
   if( (First=='E')&&(Secnd=='E') ){ First='I'; goto Alt_sym; } // ee->i:
   if( (First=='O')&&(Secnd=='O') ){ First='U'; goto Alt_sym; } // oo->u:

   if( (Secnd=='H') && strchr_P(PSTR("CSZG"),First) )goto Alt_sym; // ch sh zh th //sch(/)-ᮬ


   goto play1;

Alt_sym:
         play_fonem( pgm_read_byte(&Latin2[First-'A']) );
         Len++; //skip modifier
         return Len;

play1:
         play_fonem( pgm_read_byte(&Latin1[First-'A']) );
         return Len;
}

//=============================================================================================
