#include "compiler.h"
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <stdio.h>

#ifndef F_CPU
#define F_CPU 11059200UL
#warning "Not defined F_CPU in makefile"
#endif

#define UART_BAUD 19200

#if F_CPU < 2000000UL && defined(U2X)
#define BaudValue ((F_CPU / (8UL * UART_BAUD)) - 1   )
#define U2X_Value 1
#else
#define BaudValue ((F_CPU / (16UL * UART_BAUD)) - 1  )
#define U2X_Value 0
#endif


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void uart_init(void)
{
  UBRRH = BaudValue >> 8;
  UBRRL = BaudValue &  0xFF;
  //
  UCSRB=(1<<RXEN)|(1<<TXEN);
  sbi(DDRD,1); //TXD // initialize UART pins
  cbi(DDRD,0); //RXD
  UCSRA = (1<<U2X_Value);
}

int uart_putchar(char c, FILE *stream)
{
  if (c == '\n')uart_putchar('\r', stream);
  UDR=c; while( !(UCSRA & BV(UDRE)) );
  return 0;
}

int uart_getchar(FILE *stream)
{
  return 0;
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

FILE uart_str = FDEV_SETUP_STREAM(uart_putchar, uart_getchar, _FDEV_SETUP_RW);

void stdout_init(void)
{
  uart_init();
  stderr = stdout = stdin = &uart_str;
  printf_P(PSTR("\nStartup\n"));

}
